import random

class Connect4():
	def __init__(self, width,height,depth = 1):
		self.width = width
		self.height = height
		self.depth = depth
		self.players = [Player("X", "Left", 0), Player("O", "Left", 0)]
		self.lastPlay = [(-1, None)] # Column played, Player symbol
		self.clear()

	# TODO Make 3D
	def __repr__(self):
		returnable = ''   
		if self.depth == 1:
			for row in range( self.height ):
				returnable += '|'  
				for col in range( self.width ):
					returnable += self.data_real[col][0][row] + '|'
				returnable += '\n'
			# Separate
			returnable += '█'
			for sep in range(self.width):
				returnable += "██"		
			returnable += '\n' 
		    # numbering
			for x in range(self.width):
				returnable += f" {x%10}"
			return returnable

	def addMove(self, col, ox):
		if self.allowsMove(col, 0) == False:
			return False
		self._dropToken(self.data_real[col][0], ox)
		self.lastPlay.append((col, ox))
	#def

	def addMove_3D(self, col, dep, ox):
		if self.allowsMove(col,dep) == False:
			return # MEEBAH print or return failure to play
		self.lastPlay.append(col)
		for cell in self.data_real[col][dep]:
			if cell == ' ':
				cell = ox #replace with player reference

	def _dropToken(self, col, ox):
		# Drops the token, and cycles it down the column
		last_cell = None
		for cell in range(len(col)):
			if col[cell] == ' ':
				last_cell = cell
			else:
				col[last_cell] = ox
				self._translate_to_expected_data_format()
				return
		col[last_cell] = ox
		self._translate_to_expected_data_format()

	def delMove(self, col):
		for cell in range(len(self.data_real[col][0])):
			if self.data_real[col][0][cell] != ' ':
				self.data_real[col][0][cell] = ' '
				break
		# Clear play queue
		popper = self.lastPlay.pop()
		# Just check to see if it matches the end of the moves
		if popper[0] != col:
			# OH FUCK PUT IT BACK IN! This should never happen
			self.lastPlay.append(popper)
			

	def clear(self):
		# Intended for 3D, ran out of time
		# Last component is a complete column, 
		# This makes some other code simpler, 
		# As we can pass around whole columns
		self.data_real = []
		self.lastPlay = [(-1, None)]
		for w in range(self.width):
			sheet_plane = []
			for d in range(self.depth):
				sheet_plane.append(self._makeColumn(self.height))
			self.data_real.append(sheet_plane)

	def _translate_to_expected_data_format(self):
		self.data = []
		for row in range(self.height):
			nRoe = []
			for col in range(self.width):
				nRoe.append(self.data_real[col][0][row])
			self.data.append(nRoe)


	def _makeColumn(self, height):
		# These whole columns.
		return [' ' for i in range(height)]

	def allowsMove(self,col_w, col_d):
		if self.data_real[col_w][col_d][0] == ' ':
			return True
		return False

	def isFull(self):
		for w in range(self.width):
			for d in range(self.depth):
				if self.allowsMove(w,d):
					return False
		return True



	def winsFor(self, player):
		# Check only from played piece
		# Find last played piece
		w = self.lastPlay[-1][0]
		d = 0
		c = 0
		symbol = player.symbol
		for x in range(len(self.data_real[w][d])):
			if self.data_real[w][d][x] != ' ':
				# OK, sanity check
				if self.data_real[w][d][x] == symbol:
					c = x
					break
				else:
					#print(f"Something went wrong for player {symbol}, because {self.data[w][d][x]}")
					return

		recursionLimit = 4
		# check TWICE recursion limit - 1
		# ++ if we have symbol
		# if not reset counter
		# if counter == recursionLimit = WIN
		gexkort = [(1,0,0,"Horizontal"),(0,0,1,"Vertical"),(1,0,1,"Upslant"),(1,0,-1,"Downslant")]
		# Horizontal
		for chime in gexkort:
			counter = 0
			for x in range(-(recursionLimit-1), recursionLimit):
				#print(f"{w+(x * chime[0])},{d+(x * chime[1])},{c+(x * chime[2])}= '{self.getPiece(w+(x * chime[0]),d+(x * chime[1]),c+(x * chime[2]))}' (eval = {symbol})")
				if self.getPiece(w+(x * chime[0]),d+(x * chime[1]),c+(x * chime[2])) == symbol: 
					counter += 1
					if counter == recursionLimit:
						#print(f"Victory by {chime[3]}")
						return True
				else:
					counter = 0


	def winsFor_symbolOnly(self, symbol):
		# Check only from played piece
		# Find last played piece
		w = self.lastPlay[-1][0]
		d = 0
		c = 0
		for x in range(len(self.data_real[w][d])):
			if self.data_real[w][d][x] != ' ':
				# OK, sanity check
				if self.data_real[w][d][x] == symbol:
					c = x
					break
				else:
					#print(f"Something went wrong for player {symbol}, because {self.data[w][d][x]}")
					return

		recursionLimit = 4
		# check TWICE recursion limit - 1
		# ++ if we have symbol
		# if not reset counter
		# if counter == recursionLimit = WIN
		gexkort = [(1,0,0,"Horizontal"),(0,0,1,"Vertical"),(1,0,1,"Upslant"),(1,0,-1,"Downslant")]
		# Horizontal
		for chime in gexkort:
			counter = 0
			for x in range(-(recursionLimit-1), recursionLimit):
				#print(f"{w+(x * chime[0])},{d+(x * chime[1])},{c+(x * chime[2])}= '{self.getPiece(w+(x * chime[0]),d+(x * chime[1]),c+(x * chime[2]))}' (eval = {symbol})")
				if self.getPiece(w+(x * chime[0]),d+(x * chime[1]),c+(x * chime[2])) == symbol: 
					counter += 1
					if counter == recursionLimit:
						#print(f"Victory by {chime[3]}")
						return True
				else:
					counter = 0



	# Takes a player and finds the next one
	def nextPlayer(self, player):
		# Sanity check
		if player in self.players == False:
			print("No player")
			return None
		for i in range(len(self.players) - 1):
			if player == self.players[i]:
				#print(f"next player was {i+1}")
				return self.players[i+1]
		#print(f"next player was {0}")
		return self.players[0]

	# Get player based on symbol
	def getPlayer_bySymbol(self, symbol):
		for player in self.players:
			if symbol == player.symbol:
				return player
		return None

	def getPiece(self, w, d, c): # Width, depth, cell
		# Super helper, return occupying cell or None if out of range
		# This makes certain checks nice and easy
		# Python takes neg as index, bypass this:
		if w < 0 or d < 0 or c < 0:
			return None
		try:
			return self.data_real[w][d][c]
		except:
			pass
		return None

	def hostGame(self):
		self._addPlayer("X", "Player_1")
		self._addPlayer("O", "Player_2")
		gameRun = True
		while gameRun:
			turnCount = 1
			print(self.getPiece(0,0,0))
			print("Turn " + str(turnCount))
			for player in self.players:
				print(self)
				move = player._getMove(self)
				# Debug to delete move
				if move < 0:
					self.delMove(abs(move))
				else:
					self.addMove(move, player.symbol)
					# Check for win
					if self.winsFor(player):
						gameRun = False
						print(self)
						print(player.name + " has emerged victorious!!")
						break
				# Check for board openness
				if gameRun == True and self.isFull():
					gameRun = False
					print("The board is full, and there are no winners.\nMEMORY DELETED")
					break

	def playGameWith(self):
		self.players = []
		self._addPlayer("X", "Player_1")
		self._addPlayer("O", "Player_2")
		self.players[1].isAI = True
		self.players[1].ply = 2
		gameRun = True
		while gameRun:
			turnCount = 1
			print("Turn " + str(turnCount))
			for player in self.players:
				print(self)
				move = player._getMove(self)
				# Debug to delete move
				if move < 0:
					self.delMove(abs(move))
				else:
					self.addMove(move, player.symbol)
					# Check for win
					print(f"Wins for {player}? {self.winsFor(player)}")
					if self.winsFor(player):
						gameRun = False
						print(self)
						print(player.name + " has emerged victorious!!")
						break
				# Check for board openness
				if gameRun == True and self.isFull():
					gameRun = False
					print("The board is full, and there are no winners.\nMEMORY DELETED")
					break


	def _addPlayer(self, symbol, name):
		newPlayer = Player(symbol, "Right", -1)
		newPlayer.name = name
		self.players.append(newPlayer)

class Player():
	def __init__(self,symbol,tbt,ply):
		self.symbol = symbol
		self.name = "default"
		if ply < 0:
			self.isAI = False
		else:
			self.isAI = True
		self.tieBrakeType = tbt
		# Ply is a little consufing in this context
		self.ply = ply

	def __repr__(self) -> str:
		return self.name

	def _getMove(self, board):
		if self.isAI:
			return self.move_AISelect(board)
		else:
			return self.move_UserInput(board)

	def move_UserInput(self, board):
		move = -1
		while move == -1:
			# Input collection
			in_data = input("~ " + self.name + " ~\nWhat column to play, hmm\nMove: ")
			if int(in_data) < 0 or int(in_data) > board.width:
				print("Please input an intiger betwee 0 and " + str(board.width-1))
			elif board.allowsMove(int(in_data), 0) == False:
				print("That column is full, please select another")
			else:
				move = int(in_data)
		return move

	# technically required
	def nextMove(self, board):
		return self.move_AISelect(board) # Lol, gotem

	def move_AISelect(self, board):
		possibleMoves = self.scoreMove(board, self.ply)
		m_100 = []
		m_50 = []
		m_0 = []
		# I feel like this is a bad approach, but its clear
		for move in range(len(possibleMoves)):
			if possibleMoves[move] == 100:
				m_100.append(move)
			elif possibleMoves[move] == 50:
				m_50.append(move)
			elif possibleMoves[move] == 0:
				m_0.append(move)
		highest = m_0
		if len(m_100) > 0:
			highest = m_100
		elif len(m_50) > 0:
			highest = m_50
		# Selection
		if self.tieBrakeType == "Left":
			return highest[0]
		elif self.tieBrakeType == "Right":
			return highest[-1] 
		# leftmost is rightmost, because assembly has flipped order
		else:
			return random.choice(highest)


		#return random.randint(0,board.width-1)

	def scoresFor(self, board, symbol, ply):
		playerFromSymbol = board.getPlayer_bySymbol(symbol)
		return playerFromSymbol.scoreMove(board, ply)

	def scoreMove(self, board, ply):
		returnable = []
		#print(("\t"*ply) +  f"consider move for {self}")
		#for pane in range(board.depth): 
		# The dream of 3D is alive in portland
		for column in range(board.width):
			if board.allowsMove(column, 0):
				board.addMove(column, self.symbol) 
				# SKORE resultand boord
				if ply > 1:
					returnable.append(100 - max(board.nextPlayer(self).scoreMove(board, ply - 1)))
				else:
					returnable.append(self.scoreBoard(board))
				board.delMove(column)
			else:
				returnable.append(-1)
		return returnable
		
	def scoreBoard(self, board):
		"""Scores the board this very moment. Not recursive, only socres board"""
		for player in board.players:
			if board.winsFor(player):
				if player.symbol == self.symbol:
					return 100
				else:
					return 0
		return 50

def test():
	gamah = Connect4(8,13)
	gamah.addMove(1, "x")
	gamah.addMove(0, "x")
	gamah.addMove(1, "x")
	print(gamah)

	
def autolab_test_01():
    game = Connect4(7,5)
    game.addMove(0, "O")
    game.addMove(1, "O")
    game.addMove(2, "X")
    game.addMove(0, "X")
    game.addMove(1, "X")
    game.addMove(2, "X")
    game.addMove(0, "X")
    game.addMove(1, "O")
    game.addMove(2, "O")
    game.addMove(0, "X")
    game.addMove(1, "O")
    game.addMove(0, "O")
    game.addMove(0, "X")
    game.addMove(6, "X")
    game.addMove(6, "X")
    game.addMove(6, "X")

    game._addPlayer("X", "Player_1")
    game._addPlayer("O", "Player_2")
    ai = game.players[1]
    ai.ply = 1
    print(game)
#    print(ai.scoresFor(game, "O", 0))
#    print(ai.scoresFor(game, "O", 1))
#    print(ai.scoresFor(game, "O", 2))
#    print(ai.scoresFor(game, "O", 3))
    print(ai.scoresFor(game, "O", 4))
#    print(ai.scoresFor(game, "O", 5))

def autoLabTest_01():
	# Correct move is 3
	game = Connect4(7,5)
	game.addMove(0, 'O')
	game.addMove(1, 'O')
	game.addMove(2, 'O')
	game.addMove(0, 'X')
	game.addMove(1, 'X')
	game.addMove(2, 'X')
	game.addMove(0, 'X')
	game.addMove(1, 'O')
	game.addMove(2, 'O')
	game.addMove(0, 'X')
	game.addMove(1, 'O')
	game.addMove(0, 'O')
	game.addMove(0, 'X')
	game.addMove(0, 'X')
	game.addMove(0, 'X')
	game.addMove(0, 'X')

	# manualPlayerAdd Hack

	game._addPlayer("X", "Player_1")
	game._addPlayer("O", "Player_2")

	# AI 
	ai = Player("O", "Left", 0)
	print(game)
	print(ai.scoresFor(game, "O", 0))
	print(ai.nextMove(game))

def autoLabTest_02():
	# Correct move is 3
	expectation = 3
	game = Connect4(7,5)
	game.addMove(0, 'O')
	game.addMove(1, 'O')
	game.addMove(2, 'O')
	game.addMove(0, 'X')
	game.addMove(1, 'X')
	game.addMove(2, 'X')
	game.addMove(0, 'X')
	game.addMove(1, 'O')
	game.addMove(2, 'O')
	game.addMove(0, 'X')
	game.addMove(1, 'O')
	game.addMove(0, 'O')
	game.addMove(0, 'X')
	game.addMove(0, 'X')
	game.addMove(0, 'X')
	game.addMove(0, 'X')

	# manualPlayerAdd Hack

	#game._addPlayer("X", "Player_1")
	#game._addPlayer("O", "Player_2")

	# AI 
	ai = game.players[1]#Player("O", "Left", 0)
	print(game)
#	print(game.data)
	print(ai.scoresFor(game, "O", 0))
	answer = ai.nextMove(game)
	print(f"Expected {expectation}, got {answer}.\nCorrect? {expectation == answer}")

def autoLabTest_03():
	# Expected move 0 
	# bugged at 6
	expectation = 0
	game = Connect4(7,5)
	game.addMove(0, 'X')
	game.addMove(0, 'X')
	game.addMove(0, 'X')
	game.addMove(1, 'O')
	game.addMove(2, 'X')
	game.addMove(3, 'O')
	game.addMove(4, 'X')
	game.addMove(5, 'O')
	game.addMove(6, 'X')
	ai = game.players[1]
	print(game)
	print(ai.scoresFor(game, "O", 0))
	answer = ai.nextMove(game)
	print(f"Expected {expectation}, got {answer}.\nCorrect? {expectation == answer}")

def test_xWin_01():
	# Expected move 0 
	# bugged at 6
	expectation = 0
	game = Connect4(7,5)
	game.addMove(0, 'X')
	game.addMove(1, 'O')
	game.addMove(1, 'X')
	game.addMove(2, 'O')
	game.addMove(2, 'O')
	game.addMove(2, 'X')
	game.addMove(3, 'O')
	game.addMove(3, 'O')
	game.addMove(3, 'O')
	game.addMove(3, 'X')
	ai = game.players[1]
	print(game)
	print(game.winsFor(game.players[0]))
	#answer = ai.nextMove(game)
	#print(f"Expected {expectation}, got {answer}.\nCorrect? {expectation == answer}")

def test_xWin_02():
	# Expected move 0 
	# bugged at 6
	expectation = 0
	game = Connect4(7,5)
	game.addMove(0, 'O')
	game.addMove(0, 'O')
	game.addMove(0, 'O')
	game.addMove(0, 'X')
	game.addMove(1, 'O')
	game.addMove(1, 'O')
	game.addMove(1, 'X')
	game.addMove(2, 'O')
	game.addMove(2, 'X')
	game.addMove(3, 'X')
	ai = game.players[1]
	print(game)
	print(game.winsFor(game.players[0]))
	#answer = ai.nextMove(game)
	#print(f"Expected {expectation}, got {answer}.\nCorrect? {expectation == answer}")

def tests():
#	autoLabTest_02()
#	autoLabTest_03()
	test_xWin_01()
#	test_xWin_02()

def game():
	game = Connect4(7,5)
	game.playGameWith()

if __name__ == "__main__":
#	tests()
	game()

