import turtle

# Currently only works to create an asynkine square
# Asynkine polygons were originally published in 2022,
# in this.
# The polygon is stretched by the exgolkitivy, allowing
# it to change from a squat diamond, square, and tall diamond 
def shape_asynkine_polygon(sides, scale, exgolkitivy):
	# Less than 3 sides is not supported
	if sides < 3:
		return
	
	# Determine total internal angle
	master_angle = 180 * (sides - 2) / 2
	turtle.left(master_angle * exgolkitivy * 0.5)
	# Make sides, adjusting angles for desired effect
	for i in range(sides):
		if i % 2 == 0:
			turtle.forward(10 * scale)
			turtle.right(master_angle * exgolkitivy)
		else:
			turtle.forward(10 * scale)
			turtle.right(master_angle - master_angle * exgolkitivy)
			
	turtle.right(master_angle * exgolkitivy * 0.5)
	
def shape_asynkine_zuggurat(petals, steps, start_scale):
	# Utilizes asynkine polys in clumps rotated around the center
	# to create an interesting combined shape
	skibblerange = steps * petals
	for i in range (skibblerange):
		# To get some color variation
		hue = float((float(i)/skibblerange))
		turtle.pencolor(hue, 0.5, 0.5)
		shape_asynkine_polygon(4, start_scale * (i%steps), 1 - (i%steps)/(steps+1))
		# if we have made all the steps for this petal, move to next petal
		if i % steps == steps - 1:
			turtle.left(360 / petals)

def shape_hexagon(scale):
	turtle.forward(10*scale)
	turtle.pendown()
	turtle.left(60)
	for i in range(6):
		turtle.left(60)
		turtle.forward(10*scale)
	turtle.right(60)
	turtle.penup()
	turtle.forward(-10 * scale)

def shape_excks(scale):
	turtle.left(90)
	turtle.forward(3 * scale)
	turtle.left(45)
	turtle.pendown()
	for i in range(4):
		turtle.forward(15 * scale)
		turtle.left(90)
		turtle.forward(5 * scale)
		turtle.left(90)
		turtle.forward(15 * scale)
		turtle.left(270)
	turtle.left(-45)
	turtle.penup()
	turtle.forward(-3 * scale)
	turtle.left(-90)

def shape_ziggyGrid(width, cells_across, count):
	turtle.pendown()
	for x in range(count):
		#print("across a whole row!")
		turtle.forward(width * cells_across)
		#for y in range(5):
		if x % 2 == 1:
			#print(f"odd, {x}, {x}")
			turtle.left(-90)
			turtle.forward(width)
			turtle.left(-90)
		else: 
			#print(f"even, {x}, {x}")
			turtle.left(90)
			turtle.forward(width)
			turtle.left(90)
	#print("Done, return home")
	turtle.penup()
	if count % 2 == 1:
		turtle.left(90)
		turtle.forward(width * count)
		turtle.left(90)
		turtle.forward(-width * cells_across)
	else:
		turtle.left(-90)
		turtle.forward(width * cells_across)
		turtle.left(90)

def ship_shape_ship(scale):
	turtle.left(90)
	turtle.pendown()
	shape_asynkine_polygon(4, 1.3 * scale, 0.23)
	turtle.forward(13* scale)
	turtle.left(150)
	shape_asynkine_polygon(4, 1 * scale, 0.1)
	turtle.left(-150 * 2)
	shape_asynkine_polygon(4, 1 * scale, 0.1)
	turtle.left(150)
	turtle.forward(-13*scale)
	turtle.forward(10* scale)
	turtle.left(120)
	shape_asynkine_polygon(4, 1.2 * scale, 0.05)
	turtle.left(-120 * 2)
	shape_asynkine_polygon(4, 1.2 * scale, 0.05)
	turtle.left(120)
	turtle.forward(-10*scale)
	turtle.penup()
	turtle.left(-90)