from TarrasqueGameEngine import *
from TarrasqueGameEngine import Shapes
import Connect4
from tkinter import messagebox
import copy
import random

print("KEXGANORBIT IS THE LATEST IN HUMAN ENTERTAINMENT TECHNOLOGY")

class Paddle(GameObject):
	def __init__(self):
		super().__init__()
		self.home = Vector2(0,-350)
		self.transform.position.y = -350
		self.desired_pos = Vector2(0,-250)
		self.my_turn = False
		self.my_symbol = "X"

	def beginTurn(self):
		self.my_turn = True

	def _update(self):
		d_dist = self.desired_pos.distance(self.transform.position)
		self.desired_pos = GAME.In_mousePos
	#	if d_dist < 2:
	#		if self.desired_x != 0:
	#			self.desired_pos = GAME.In_mousePos
	#		else:
	#			self.desired_pos.x = self.home[0] + random.randint(-40, 40)
	#			self.desired_pos.y = self.home[0] + random.randint(-40, 40)
		max_vel = 500
		acc_pow = 8
		self.body.velocity.x = clamp((self.desired_pos.x - self.transform.position.x) * acc_pow, -max_vel, max_vel)
		self.body.velocity.y = clamp((self.desired_pos.y - self.transform.position.y) * acc_pow, -max_vel, max_vel)	
		super()._update() # Disabled to prevent toroidal wrap

		if GAME.In_click_down and self.my_turn:
			self.pewulate()
		
	def pewulate(self):
		self.my_turn = False
		bullet = Bullet()
		bullet.transform.position = copy.copy(self.transform.position)
		bullet.symbol = "X"
		GAME.addGameObject(bullet)
		#BOARD._collision_check(GAME.In_lastClick.x, GAME.In_lastClick.y)
		#messagebox.showinfo('Tic-Tac-Toe', 'Game Over! Human Wins!')

	def _draw(self):
		self.transform.pen_to_pos()
		if self.my_turn:
			turtle.color(0, 1,1)
			Shapes.ship_shape_ship(2)
		else:
			turtle.color(0, 0.6, 0.6)
			Shapes.ship_shape_ship(1)
		turtle.color("white")
		self.transform.return_pen_home()

class EnemyPaddle(GameObject):
	def __init__(self):
		super().__init__()
		self.home = Vector2(0,-350)
		self.transform.position.y = -350
		self.desired_pos = Vector2(0,0)
		self.my_turn = False
		self.my_symbol = "O"
		self.desired_move = None
		self.my_AI = Connect4.Player("O", "Random", 4)
	
	def _update(self):
		d_dist = self.desired_pos.distance(self.transform.position)
		if self.desired_move == None:
			self.desired_move = self.my_AI.move_AISelect(BOARD.game_board)
			print(self.desired_move)
		self.desired_pos = Vector2(self.desired_move * BOARD.cell_size - ((BOARD.cell_size * BOARD.game_board.width) / 2) + (BOARD.cell_size / 2) + random.randint(-10, 10), -350 + random.randint(-40, 40))

		max_vel = 500
		acc_pow = 3
		self.body.velocity.x = clamp((self.desired_pos.x - self.transform.position.x) * acc_pow, -max_vel, max_vel)
		self.body.velocity.y = clamp((self.desired_pos.y - self.transform.position.y) * acc_pow, -max_vel, max_vel)	
		super()._update() # Disabled to prevent toroidal wrap

		if d_dist < 10 and self.my_turn:
			self.pewulate()

	def beginTurn(self):
		self.my_turn = True
		self.desired_move = self.my_AI.move_AISelect(BOARD.game_board)
		
	def pewulate(self):
		self.my_turn = False
		bullet = Bullet()
		bullet.transform.position = copy.copy(self.transform.position)
		bullet.symbol = "O"
		GAME.addGameObject(bullet)

	def _draw(self):
		self.transform.pen_to_pos()
		if self.my_turn:
			turtle.color(1, 0,0)
			Shapes.ship_shape_ship(2)
		else:
			turtle.color(0.6, 0, 0)
			Shapes.ship_shape_ship(1)
		turtle.color("white")
		self.transform.return_pen_home()

class SeaFloorGrid(GameObject):
	def __init__(self):
		super().__init__()
		self.transform.position.x = -340
		self.transform.position.y = -250

		self.cell_size = 100
		
		self.game_board = Connect4.Connect4(7,5)

		self.player1 = None
		self.player2 = None
		self.currentPlayer = 0

	def goToNextPlayer(self):
		if self.currentPlayer == 0:
			if BOARD.game_board.winsFor_symbolOnly(self.player1.my_symbol):
				messagebox.showinfo('MCP', 'Game Over! Human Wins!')
				BOARD.game_board.clear()
			if BOARD.game_board.isFull():
				messagebox.showinfo('MCP', 'Board is full, that means MASTER CONTROL PROGRAM Wins by default!')
				BOARD.game_board.clear()
			self.player2.beginTurn()
			self.currentPlayer = 1
		else:
			if BOARD.game_board.winsFor_symbolOnly(self.player2.my_symbol):
				messagebox.showinfo('MCP', 'Game Over! MASTER CONTROL PROGRAM Wins!')
				BOARD.game_board.clear()
			if BOARD.game_board.isFull():
				messagebox.showinfo('MCP', 'Board is full, that means MASTER CONTROL PROGRAM Wins by default!')
				BOARD.game_board.clear()
			
			self.player1.beginTurn()
			self.currentPlayer = 0

	def _draw(self):
		# Draw GRID
		self.transform.pen_to_pos()
		Shapes.shape_ziggyGrid(self.cell_size, self.game_board.width,self.game_board.height)
		turtle.forward(self.cell_size * self.game_board.width)
		turtle.left(90)
		Shapes.shape_ziggyGrid(self.cell_size, self.game_board.height, self.game_board.width)
		turtle.left(-90)
		turtle.forward(-self.cell_size * self.game_board.width)
		
		# Draw CELLS
		
		offset = Transform()
		for row in range( self.game_board.height ):
			offset.position.y = row * self.cell_size + (self.cell_size * 0.5)
			for col in range( self.game_board.width ):
				offset.position.x = col * self.cell_size + (self.cell_size * 0.5)
				if self.game_board.data_real[col][0][row] == " ":
					continue
				offset.pen_to_pos()
				if self.game_board.data_real[col][0][row] == "X":
					turtle.color(0, 0.6, 0.6)
					Shapes.shape_excks(2.5)
				elif self.game_board.data_real[col][0][row] == "O":
					turtle.color(0.6, 0, 0)
					Shapes.shape_hexagon(2.9)
					turtle.left(30)
					Shapes.shape_hexagon(2.9)
					turtle.left(-30)
				offset.return_pen_home()
		self.transform.return_pen_home()
		turtle.color("white")

	def _collision_check(self, bullet, world_x, world_y):
		# Check against occupied cells
		# Check if in column
		# Compute local point
		local_x = world_x - self.transform.position.x
		local_y = world_y - self.transform.position.y
	#	print(f"World: {world_x}, {world_x}")
	#	print(f"Local: {local_x}, {local_y}")
	#	print(f"Cell: {int(local_x / self.cell_size)}, {int(local_y / self.cell_size)}")
		if local_x < 0 or local_y < 0:
			# Out of bounds
			return False
		if int(local_x / self.cell_size) >= self.game_board.width or int(local_y / self.cell_size) >= self.game_board.height:
			# OOB
			return False
		# Grid is all built out from 0, so this part is easy at least
		pot_cell = self.game_board.data_real[int(local_x / self.cell_size)][0][int(local_y / self.cell_size)]
		if pot_cell == " " and int(local_y / self.cell_size) < self.game_board.height -1:
			return False
		# Apply Move
		BOARD.game_board.addMove(int(local_x / self.cell_size), bullet.symbol)
		return True

class Bullet(GameObject):
	def __init__(self):
		super().__init__()
		self.body.velocity.y = 350
		self.body.ang_vel = 22000
		self.symbol = ""
		self.timer = 2.5
		self.enabled = True

	def _draw(self):
		self.transform.pen_to_pos()
		if self.symbol == "X":
			Shapes.shape_excks(0.25 + (0.75 * (self.timer / 2.5)))
		if self.symbol == "O":
			Shapes.shape_hexagon(1.2 * (0.25 + (0.75 * (self.timer / 2.5))))
			turtle.left(30)
			Shapes.shape_hexagon(1.2 * (0.25 + (0.75 * (self.timer / 2.5))))
			turtle.left(-30)
		self.transform.return_pen_home()

	def _update(self):
		super()._update()
		self.timer -= 0.033 # Framerate
		if self.timer < 0:
			# Freeze and clear self
			self.enabled = False
			GAME.destroyGameObject(self)
			# Re enable player gun
			if self.symbol == "X":
				BOARD.player1.beginTurn()
			elif self.symbol == "O":
				BOARD.player2.beginTurn()
		if self.enabled == True and BOARD._collision_check(self, self.transform.position.x, self.transform.position.y):
			self.enabled = False
			self.body.velocity.y = 0
			BOARD.goToNextPlayer()
			GAME.destroyGameObject(self)



GAME = None
BOARD = None

if __name__ == "__main__":
	# BEGIN GAEM
	GAME = EngineInstance()
	player_01 = Paddle()
	player_02 = EnemyPaddle()
	the_grid = SeaFloorGrid()
	the_grid.player1 = player_01
	the_grid.player2 = player_02
	player_01.my_turn = True
	BOARD = the_grid
	GAME.addGameObject(player_01)
	GAME.addGameObject(player_02)
	GAME.addGameObject(the_grid)
	GAME.Start()
